#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk_imlib.h>

#include "callbacks.h"
#include "interface.h"
#include "rr_main.h"
#include "rr_screen.h"



void
on_screen_destroy                      (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


gboolean
on_screen_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  return FALSE;
}


gboolean
on_draw_area_expose_event              (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  return((gboolean)RRScreenRedraw(widget, event, user_data));
}



void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_rot1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(0, -1.0);
}


void
on_rot2_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(1, -1.0);
}


void
on_rot3_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(2, -1.0);
}


void
on_rot4_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(3, -1.0);
}


void
on_zoom1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(-1, 0.25);
}


void
on_zoom2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(-1, 0.50);
}


void
on_zoom3_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(-1, 1.00);
}


void
on_zoom4_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(-1, 2.00);
}


void
on_zoom5_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  ChangeRot(-1, 4.00);
}

