/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

GtkWidget*
create_screen ()
{
  GtkWidget *screen;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *file1;
  GtkWidget *file1_menu;
  GtkAccelGroup *file1_menu_accels;
  GtkWidget *quit1;
  GtkWidget *routine1;
  GtkWidget *routine1_menu;
  GtkAccelGroup *routine1_menu_accels;
  GtkWidget *rot1;
  GtkWidget *rot2;
  GtkWidget *rot3;
  GtkWidget *rot4;
  GtkWidget *zoom;
  GtkWidget *zoom_menu;
  GtkAccelGroup *zoom_menu_accels;
  GtkWidget *zoom1;
  GtkWidget *zoom2;
  GtkWidget *zoom3;
  GtkWidget *zoom4;
  GtkWidget *zoom5;
  GtkWidget *drawing_area;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  screen = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (screen, "screen");
  gtk_object_set_data (GTK_OBJECT (screen), "screen", screen);
  gtk_widget_set_events (screen, GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK);
  gtk_window_set_title (GTK_WINDOW (screen), "pixrot");
  gtk_window_set_policy (GTK_WINDOW (screen), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (screen), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (screen), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar1, "menubar1");
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (screen), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (menubar1), 1);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (menubar1), GTK_SHADOW_ETCHED_OUT);

  file1 = gtk_menu_item_new_with_label ("File");
  gtk_widget_set_name (file1, "file1");
  gtk_widget_ref (file1);
  gtk_object_set_data_full (GTK_OBJECT (screen), "file1", file1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file1);
  gtk_container_add (GTK_CONTAINER (menubar1), file1);

  file1_menu = gtk_menu_new ();
  gtk_widget_set_name (file1_menu, "file1_menu");
  gtk_widget_ref (file1_menu);
  gtk_object_set_data_full (GTK_OBJECT (screen), "file1_menu", file1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file1), file1_menu);
  file1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file1_menu));

  quit1 = gtk_menu_item_new_with_label ("Quit");
  gtk_widget_set_name (quit1, "quit1");
  gtk_widget_ref (quit1);
  gtk_object_set_data_full (GTK_OBJECT (screen), "quit1", quit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quit1);
  gtk_container_add (GTK_CONTAINER (file1_menu), quit1);
  gtk_widget_add_accelerator (quit1, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  routine1 = gtk_menu_item_new_with_label ("Routine");
  gtk_widget_set_name (routine1, "routine1");
  gtk_widget_ref (routine1);
  gtk_object_set_data_full (GTK_OBJECT (screen), "routine1", routine1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (routine1);
  gtk_container_add (GTK_CONTAINER (menubar1), routine1);

  routine1_menu = gtk_menu_new ();
  gtk_widget_set_name (routine1_menu, "routine1_menu");
  gtk_widget_ref (routine1_menu);
  gtk_object_set_data_full (GTK_OBJECT (screen), "routine1_menu", routine1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (routine1), routine1_menu);
  routine1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (routine1_menu));

  rot1 = gtk_menu_item_new_with_label ("rot1");
  gtk_widget_set_name (rot1, "rot1");
  gtk_widget_ref (rot1);
  gtk_object_set_data_full (GTK_OBJECT (screen), "rot1", rot1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rot1);
  gtk_container_add (GTK_CONTAINER (routine1_menu), rot1);

  rot2 = gtk_menu_item_new_with_label ("rot2");
  gtk_widget_set_name (rot2, "rot2");
  gtk_widget_ref (rot2);
  gtk_object_set_data_full (GTK_OBJECT (screen), "rot2", rot2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rot2);
  gtk_container_add (GTK_CONTAINER (routine1_menu), rot2);

  rot3 = gtk_menu_item_new_with_label ("rot3");
  gtk_widget_set_name (rot3, "rot3");
  gtk_widget_ref (rot3);
  gtk_object_set_data_full (GTK_OBJECT (screen), "rot3", rot3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rot3);
  gtk_container_add (GTK_CONTAINER (routine1_menu), rot3);

  rot4 = gtk_menu_item_new_with_label ("rot4");
  gtk_widget_set_name (rot4, "rot4");
  gtk_widget_ref (rot4);
  gtk_object_set_data_full (GTK_OBJECT (screen), "rot4", rot4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rot4);
  gtk_container_add (GTK_CONTAINER (routine1_menu), rot4);

  zoom = gtk_menu_item_new_with_label ("Zoom");
  gtk_widget_set_name (zoom, "zoom");
  gtk_widget_ref (zoom);
  gtk_object_set_data_full (GTK_OBJECT (screen), "zoom", zoom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom);
  gtk_container_add (GTK_CONTAINER (menubar1), zoom);

  zoom_menu = gtk_menu_new ();
  gtk_widget_set_name (zoom_menu, "zoom_menu");
  gtk_widget_ref (zoom_menu);
  gtk_object_set_data_full (GTK_OBJECT (screen), "zoom_menu", zoom_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (zoom), zoom_menu);
  zoom_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (zoom_menu));

  zoom1 = gtk_menu_item_new_with_label ("0.25");
  gtk_widget_set_name (zoom1, "zoom1");
  gtk_widget_ref (zoom1);
  gtk_object_set_data_full (GTK_OBJECT (screen), "zoom1", zoom1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom1);
  gtk_container_add (GTK_CONTAINER (zoom_menu), zoom1);

  zoom2 = gtk_menu_item_new_with_label ("0.5");
  gtk_widget_set_name (zoom2, "zoom2");
  gtk_widget_ref (zoom2);
  gtk_object_set_data_full (GTK_OBJECT (screen), "zoom2", zoom2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom2);
  gtk_container_add (GTK_CONTAINER (zoom_menu), zoom2);

  zoom3 = gtk_menu_item_new_with_label ("1.0");
  gtk_widget_set_name (zoom3, "zoom3");
  gtk_widget_ref (zoom3);
  gtk_object_set_data_full (GTK_OBJECT (screen), "zoom3", zoom3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom3);
  gtk_container_add (GTK_CONTAINER (zoom_menu), zoom3);

  zoom4 = gtk_menu_item_new_with_label ("2.0");
  gtk_widget_set_name (zoom4, "zoom4");
  gtk_widget_ref (zoom4);
  gtk_object_set_data_full (GTK_OBJECT (screen), "zoom4", zoom4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom4);
  gtk_container_add (GTK_CONTAINER (zoom_menu), zoom4);

  zoom5 = gtk_menu_item_new_with_label ("4.0");
  gtk_widget_set_name (zoom5, "zoom5");
  gtk_widget_ref (zoom5);
  gtk_object_set_data_full (GTK_OBJECT (screen), "zoom5", zoom5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom5);
  gtk_container_add (GTK_CONTAINER (zoom_menu), zoom5);

  drawing_area = gtk_drawing_area_new ();
  gtk_widget_set_name (drawing_area, "drawing_area");
  gtk_widget_ref (drawing_area);
  gtk_object_set_data_full (GTK_OBJECT (screen), "drawing_area", drawing_area,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawing_area);
  gtk_box_pack_start (GTK_BOX (vbox1), drawing_area, TRUE, TRUE, 0);
  gtk_widget_set_usize (drawing_area, 256, 256);

  gtk_signal_connect (GTK_OBJECT (screen), "destroy",
                      GTK_SIGNAL_FUNC (on_screen_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (screen), "button_press_event",
                      GTK_SIGNAL_FUNC (on_screen_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quit1), "activate",
                      GTK_SIGNAL_FUNC (on_quit1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (rot1), "activate",
                      GTK_SIGNAL_FUNC (on_rot1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (rot2), "activate",
                      GTK_SIGNAL_FUNC (on_rot2_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (rot3), "activate",
                      GTK_SIGNAL_FUNC (on_rot3_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (rot4), "activate",
                      GTK_SIGNAL_FUNC (on_rot4_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (zoom1), "activate",
                      GTK_SIGNAL_FUNC (on_zoom1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (zoom2), "activate",
                      GTK_SIGNAL_FUNC (on_zoom2_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (zoom3), "activate",
                      GTK_SIGNAL_FUNC (on_zoom3_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (zoom4), "activate",
                      GTK_SIGNAL_FUNC (on_zoom4_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (zoom5), "activate",
                      GTK_SIGNAL_FUNC (on_zoom5_activate),
                      NULL);

  gtk_widget_grab_focus (screen);
  gtk_window_add_accel_group (GTK_WINDOW (screen), accel_group);

  return screen;
}

