/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Mar.16.1999  Programing start
  Mar.18.2000  Sample Version.

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMain           -- ֤˥뤵ᥤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include  "rr_main.h"
#include  "rr_screen.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- եåǡ */
#include  "../picture/lm_penguin.xpm"


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void       RotFace(void);

void rot1(GdkPixbuf*, GdkPixbuf*, gint, gfloat);
void rot2(GdkPixbuf*, GdkPixbuf*, gint, gfloat);
void rot3(GdkPixbuf*, GdkPixbuf*, gint, gfloat);
void rot4(GdkPixbuf*, GdkPixbuf*, gint, gfloat);

guint32 smooth_pixel(GdkPixbuf*, gint, gint,
		     gint, gint, gint, gint, gfloat, gfloat);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

gint  timer;

/* --- ɽ륭饯 */
GdkPixbuf *pic;

/* --- եå */
gint  fw, fh, fs;

/* --- ž르ꥺ */
gint  rot_routine;

/* --- ΨȤɸ */
gfloat  z_now, z_aim;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  timer = 0;
  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-26-*-*-*-*-*-*-*,\
            -misc-fixed-medium-*-normal-*-24-*-*-*-*-*-jisx0208.1983-0");

  /* -- եå pixmap  */
  pic = gdk_pixbuf_new_from_xpm_data(lm_penguin_xpm);

  /* -- ǥեȥեå */
  RRScreenClear(0, 0, 0);

  /* -- GdkRGB ν */
  gdk_rgb_init();

  rot_routine = 2;
  z_now = 1.0;
  z_aim = 1.0;
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (pic != NULL) gdk_pixbuf_unref(pic);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  timer++;

  /* --- եåùɽ */
  RotFace();

  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  return 1;
}




/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
  fs = 0;
}




/* -------------------------------------------------------------
  RRMainWindowClean   -- ̽񤭴

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowClean(void)
{
  RRScreenClear(0, 0, 0);
}



/* -------------------------------------------------------------
  RotFace       -- ץ륰եåž

   return : void
   gint   n     ž르ꥺֹ
   gfloat zoom  Ψ
-------------------------------------------------------------- */
void       ChangeRot(gint n, gfloat zoom)
{
  if (n >= 0) rot_routine = n;
  if (zoom >= 0) z_aim = zoom;
}

/* -------------------------------------------------------------
  RotFace       -- ץ륰եåž

   return : void
   void
-------------------------------------------------------------- */
void       RotFace(void)
{
  GdkPixbuf *chr;
  GdkPixmap *spr;
  GdkGC     *gc;
  gint  w, h;

  w = gdk_pixbuf_get_width(pic);
  h = gdk_pixbuf_get_height(pic);

  chr = gdk_pixbuf_new(ART_PIX_RGB, TRUE, 8, 256, 256);
  /* --- ž */
  switch(rot_routine) {
  case 0:
    rot1(pic, chr, (timer % 360), z_now);
    break;
  case 1:
    rot2(pic, chr, (timer % 360), z_now);
    break;
  case 2:
    rot3(pic, chr, (timer % 360), z_now);
    break;
  case 3:
    rot4(pic, chr, (timer % 360), z_now);
    break;
  }

  spr = gdk_pixmap_new(RRScreenCanvas()->window, 256, 256, -1);
  gc = gdk_gc_new(spr);
  gdk_pixbuf_render_to_drawable(chr, spr, gc,
				0, 0, 0, 0, 256, 256,
				GDK_RGB_DITHER_NONE, 0, 0);
  RRScreenPutPixmap(spr, 0, 0);
  gdk_gc_destroy(gc);
  gdk_pixbuf_unref(chr);
  gdk_pixmap_unref(spr);

  /* --- Ψܹ */
  if (z_now != z_aim) {
    if (fabs(z_now - z_aim) < 0.05) {
      /* --- ׻ۼ */
      z_now = z_aim;
    }
    else {
      if (z_now > z_aim) z_now -= 0.05;
      if (z_now < z_aim) z_now += 0.05;
    }
  }
}



/* -------------------------------------------------------------
    žμ¸
-------------------------------------------------------------- */
void rot1(GdkPixbuf *src, GdkPixbuf *dist, gint r, gfloat m)
{
  gint  w1, h1, w2, h2;
  gint  x1, y1, x2, y2;
  gint  px1, py1, px2, py2;
  gint  i, j;
  guint32  *ptr1, *ptr2;
  guchar   *ptr;

  w1 = gdk_pixbuf_get_width(src);
  h1 = gdk_pixbuf_get_height(src);
  w2 = gdk_pixbuf_get_width(dist);
  h2 = gdk_pixbuf_get_height(dist);
  px1 = w1 / 2;
  py1 = h1 / 2;
  px2 = w2 / 2;
  py2 = h2 / 2;

  r = 360 - r;

  ptr1 = (guint32*)gdk_pixbuf_get_pixels(src);
  for(j=0; j<h1; j++) {
    for(i=0; i<w1; i++) {
      x1 = i;
      y1 = j;
      x2 = ((x1 - px1) * cos(M_PI*2/360*r) + (y1 - py1) * sin(M_PI*2/360*r)) * m + px2;
      y2 = ((y1 - py1) * cos(M_PI*2/360*r) - ((x1 - px1) * sin(M_PI*2/360*r))) * m + py2;
      if ((x2 >= 0) && (x2 < w2) && (y2 >= 0) && (y2 < h2)) {
	ptr = gdk_pixbuf_get_pixels(dist) + gdk_pixbuf_get_rowstride(dist) * y2 + (x2 * 4);
	ptr2 = (guint32 *)ptr;
	*ptr2 = *ptr1;
      }
      ptr1++;
    }
  }
}



void rot2(GdkPixbuf *src, GdkPixbuf *dist, gint r, gfloat m)
{
  gint  w1, h1, w2, h2;
  gint  x1, y1, x2, y2;
  gint  px1, py1, px2, py2;
  gint  i, j;
  guint32  *ptr1, *ptr2;
  guchar   *ptr;

  w1 = gdk_pixbuf_get_width(src);
  h1 = gdk_pixbuf_get_height(src);
  w2 = gdk_pixbuf_get_width(dist);
  h2 = gdk_pixbuf_get_height(dist);
  px1 = w1 / 2;
  py1 = h1 / 2;
  px2 = w2 / 2;
  py2 = h2 / 2;

  ptr2 = (guint32*)gdk_pixbuf_get_pixels(dist);
  for(j=0; j<h2; j++) {
    for(i=0; i<w2; i++) {
      x2 = i;
      y2 = j;
      x1 = ((x2 - px2) * cos(M_PI*2/360*r) + (y2 - py2) * sin(M_PI*2/360*r)) * (1 / m) + px1;
      y1 = ((y2 - py2) * cos(M_PI*2/360*r) - ((x2 - px2) * sin(M_PI*2/360*r))) * (1 / m) + py1;
      if ((x1 >= 0) && (x1 < w1) && (y1 >= 0) && (y1 < h1)) {
	ptr = gdk_pixbuf_get_pixels(src) + gdk_pixbuf_get_rowstride(src) * y1 + (x1 * 4);
	ptr1 = (guint32 *)ptr;
	*ptr2 = *ptr1;
      }
      else {
	*ptr2 = 0;
      }
      ptr2++;
    }
  }
}



void rot3(GdkPixbuf *src, GdkPixbuf *dist, gint r, gfloat m)
{
  gint  w1, h1, w2, h2;
  gint  x1, y1, x2, y2;
  gint  dx1, dy1, dx2, dy2;
  gint  px1, py1, px2, py2;
  gint  i, j;
  guint32  *ptr1, *ptr2;
  guchar   *ptr, *buf;
  gint      buf_size;

  w1 = gdk_pixbuf_get_width(src);
  h1 = gdk_pixbuf_get_height(src);
  w2 = gdk_pixbuf_get_width(dist);
  h2 = gdk_pixbuf_get_height(dist);
  px1 = w1 / 2;
  py1 = h1 / 2;
  px2 = w2 / 2;
  py2 = h2 / 2;
  buf = gdk_pixbuf_get_pixels(src);
  buf_size = gdk_pixbuf_get_rowstride(src);

  ptr2 = (guint32*)gdk_pixbuf_get_pixels(dist);
  x1 = (((0 - px2) * cos(M_PI*2/360*r) + (0 - py2) * sin(M_PI*2/360*r)) * (1 / m) + px1) * 0x10000;
  y1 = (((0 - py2) * cos(M_PI*2/360*r) - (0 - px2) * sin(M_PI*2/360*r)) * (1 / m) + py1) * 0x10000;
  dx1 = (((1 - px2) * cos(M_PI*2/360*r) + (0 - py2) * sin(M_PI*2/360*r)) * (1 / m) + px1) * 0x10000;
  dy1 = (((0 - py2) * cos(M_PI*2/360*r) - (1 - px2) * sin(M_PI*2/360*r)) * (1 / m) + py1) * 0x10000;
  dx2 = (((0 - px2) * cos(M_PI*2/360*r) + (1 - py2) * sin(M_PI*2/360*r)) * (1 / m) + px1) * 0x10000;
  dy2 = (((1 - py2) * cos(M_PI*2/360*r) - (0 - px2) * sin(M_PI*2/360*r)) * (1 / m) + py1) * 0x10000;
  dx1 -= x1;
  dy1 -= y1;
  dx2 -= x1;
  dy2 -= y1;
  w1 <<= 16;
  h1 <<= 16;
  for(j=0; j<h2; j++) {
    x2 = x1;
    y2 = y1;
    for(i=0; i<w2; i++) {
      if ((x2 >= 0) && (x2 < w1) && (y2 >= 0) && (y2 < h1)) {
	ptr = buf +  buf_size * (y2 >> 16) + ((x2 >> 16) * 4);
	ptr1 = (guint32 *)ptr;
	*ptr2 = *ptr1;
      }
      else {
	*ptr2 = 0;
      }
      ptr2++;
      x2 += dx1;
      y2 += dy1;
    }
    x1 += dx2;
    y1 += dy2;
  }
}


void rot4(GdkPixbuf *src, GdkPixbuf *dist, gint r, gfloat m)
{
  gint  w1, h1, w2, h2;
  gint  x1, y1, x2, y2;
  gint  dx1, dy1, dx2, dy2;
  gint  px1, py1, px2, py2;
  gint  i, j;
  guint32  *ptr2;

  w1 = gdk_pixbuf_get_width(src);
  h1 = gdk_pixbuf_get_height(src);
  w2 = gdk_pixbuf_get_width(dist);
  h2 = gdk_pixbuf_get_height(dist);
  px1 = w1 / 2;
  py1 = h1 / 2;
  px2 = w2 / 2;
  py2 = h2 / 2;

  ptr2 = (guint32*)gdk_pixbuf_get_pixels(dist);
  x1 = (((0 - px2) * cos(M_PI*2/360*r) + (0 - py2) * sin(M_PI*2/360*r)) * (1 / m) + px1) * 0x10000;
  y1 = (((0 - py2) * cos(M_PI*2/360*r) - (0 - px2) * sin(M_PI*2/360*r)) * (1 / m) + py1) * 0x10000;
  dx1 = (((1 - px2) * cos(M_PI*2/360*r) + (0 - py2) * sin(M_PI*2/360*r)) * (1 / m) + px1) * 0x10000;
  dy1 = (((0 - py2) * cos(M_PI*2/360*r) - (1 - px2) * sin(M_PI*2/360*r)) * (1 / m) + py1) * 0x10000;
  dx2 = (((0 - px2) * cos(M_PI*2/360*r) + (1 - py2) * sin(M_PI*2/360*r)) * (1 / m) + px1) * 0x10000;
  dy2 = (((1 - py2) * cos(M_PI*2/360*r) - (0 - px2) * sin(M_PI*2/360*r)) * (1 / m) + py1) * 0x10000;
  dx1 -= x1;
  dy1 -= y1;
  dx2 -= x1;
  dy2 -= y1;
  w1 <<= 16;
  h1 <<= 16;
  for(j=0; j<h2; j++) {
    x2 = x1;
    y2 = y1;
    for(i=0; i<w2; i++) {
      if ((x2 >= 0) && (x2 < w1) && (y2 >= 0) && (y2 < h1)) {
	*ptr2 = smooth_pixel(src, x2, y2, dx1, dy1, dx2, dy2, m, m);
      }
      else {
	*ptr2 = 0;
      }
      ptr2++;
      x2 += dx1;
      y2 += dy1;
    }
    x1 += dx2;
    y1 += dy2;
  }
}



/* -------------------------------------------------------------
    ԥ륹ࡼ
-------------------------------------------------------------- */
guint32 smooth_pixel(GdkPixbuf *pic,
		     gint x, gint y,
		     gint dx1, gint dy1, gint dx2, gint dy2,
		     gfloat mx, gfloat my)
{
  guchar   *ptr1, *ptr2;
  guint     r, g, b, a;
  guint     r1, g1, b1, a1;
  guint     r2, g2, b2, a2;
  guint     ro, go, bo, ao;
  gint      blend, times;
  gint      x_loop, y_loop, tx, ty;

  ro = go = bo = ao = 0;
  blend = 0;

  x_loop = (gint)(1 / mx) + 1;
  y_loop = (gint)(1 / my) + 1;
  dx1 /= x_loop;
  dy1 /= y_loop;
  dx2 /= x_loop;
  dy2 /= y_loop;

  do {
    tx = x;
    ty = y;
    do {
      ptr1 = gdk_pixbuf_get_pixels(pic) +
	gdk_pixbuf_get_rowstride(pic) * (y >> 16) + ((x >> 16) * 4);
      ptr2 = gdk_pixbuf_get_pixels(pic) +
	gdk_pixbuf_get_rowstride(pic) * ((y >> 16) + 1) + ((x >> 16) * 4);

      if (((x >> 16) >= gdk_pixbuf_get_width(pic))
	  || ((y >> 16) >= gdk_pixbuf_get_height(pic))) {
	break;
      }

      r = g = b = a = 0;

      times = (x & 0xffff) >> 8;
      if (times > 0x40) {
	times -= 0x40;
	r1 = ptr1[0] * (0xc0 - times) + ptr1[4] * times;
	g1 = ptr1[1] * (0xc0 - times) + ptr1[5] * times;
	b1 = ptr1[2] * (0xc0 - times) + ptr1[6] * times;
	a1 = ptr1[3] * (0xc0 - times) + ptr1[7] * times;
	r2 = ptr2[0] * (0xc0 - times) + ptr2[4] * times;
	g2 = ptr2[1] * (0xc0 - times) + ptr2[5] * times;
	b2 = ptr2[2] * (0xc0 - times) + ptr2[6] * times;
	a2 = ptr2[3] * (0xc0 - times) + ptr2[7] * times;
      }
      else {
	r1 = ptr1[0] * 0xc0;
	g1 = ptr1[1] * 0xc0;
	b1 = ptr1[2] * 0xc0;
	a1 = ptr1[3] * 0xc0;
	r2 = ptr2[0] * 0xc0;
	g2 = ptr2[1] * 0xc0;
	b2 = ptr2[2] * 0xc0;
	a2 = ptr2[3] * 0xc0;
      }
      times = (y & 0xffff) >> 8;
      if (times > 0x40) {
	times -= 0x40;
	r = r1 * (0xc0 - times) + r2 * times;
	g = g1 * (0xc0 - times) + g2 * times;
	b = b1 * (0xc0 - times) + b2 * times;
	a = a1 * (0xc0 - times) + a2 * times;
      }
      else {
	r = r1 * 0xc0;
	g = g1 * 0xc0;
	b = b1 * 0xc0;
	a = a1 * 0xc0;
      }
      r /= 0xc0 * 0xc0;
      g /= 0xc0 * 0xc0;
      b /= 0xc0 * 0xc0;
      a /= 0xc0 * 0xc0;
      ro += r;
      go += g;
      bo += b;
      ao += a;
      blend++;
      x += dx1;
      y += dy1;
      x_loop--;
    } while(x_loop > 1);
    x = tx;
    y = ty;
    x += dx2;
    y += dy2;
    y_loop--;
  }while(y_loop > 1);

  r = ro / blend;
  g = go / blend;
  b = bo / blend;
  a = ao / blend;

  if (r > 0x100) r = 0xff;
  if (g > 0x100) g = 0xff;
  if (b > 0x100) b = 0xff;
  if (a > 0x100) a = 0xff;
  return(r | (g<<8) | (b<<16) | (a<<24));
}



